import { Symbol } from 'typescript';
import { ClassLikeExportDoc } from '../api-doc-types/ClassLikeExportDoc';
import { MemberDoc } from '../api-doc-types/MemberDoc';
import { ModuleDoc } from '../api-doc-types/ModuleDoc';
/**
 * Classes are Class-like but also can contain static members
 * and cannot have multiple declarations
 */
export declare class ClassExportDoc extends ClassLikeExportDoc {
    docType: string;
    constructorDoc: MemberDoc;
    statics: MemberDoc[];
    constructor(moduleDoc: ModuleDoc, symbol: Symbol, basePath: string, hidePrivateMembers: boolean, namespacesToInclude: string[]);
}
