"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var getDeclarationTypeText_1 = require("./getDeclarationTypeText");
function getParameters(declaration, namespacesToInclude) {
    var parameters = getParameterDeclarations(declaration);
    if (!parameters) {
        var name = declaration.name ? declaration.name.getText() : 'unknown';
        throw new Error("Missing declaration parameters for \"" + name + "\" in " + declaration.getSourceFile().fileName + " at line " + declaration.getStart());
    }
    return parameters.map(function (parameter) {
        var paramText = '';
        if (parameter.dotDotDotToken)
            paramText += '...';
        paramText += parameter.name.getText();
        if (parameter.questionToken)
            paramText += '?';
        paramText += (!parameter.type && parameter.initializer) ? ' = ' : ': ';
        paramText += getDeclarationTypeText_1.getDeclarationTypeText(parameter, namespacesToInclude);
        return paramText.trim();
    });
}
exports.getParameters = getParameters;
function getParameterDeclarations(declaration) {
    return declaration.parameters;
}
//# sourceMappingURL=getParameters.js.map